Index: java/main/src/main/java/com/framsticks/params/InvalidOperationException.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/InvalidOperationException.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/params/InvalidOperationException.java	(revision 101)
@@ -1,8 +1,8 @@
 package com.framsticks.params;
 
-import com.framsticks.util.UnsupportedOperationException;
+import com.framsticks.util.FramsticksUnsupportedOperationException;
 
 @SuppressWarnings("serial")
-public class InvalidOperationException extends UnsupportedOperationException {
+public class InvalidOperationException extends FramsticksUnsupportedOperationException {
 
 }
Index: java/main/src/main/java/com/framsticks/params/ListAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 101)
@@ -7,5 +7,4 @@
 import com.framsticks.params.types.EventParam;
 import com.framsticks.params.types.ProcedureParam;
-import com.framsticks.util.UnimplementedException;
 
 /**
@@ -30,27 +29,4 @@
 	// }
 
-	@Override
-	public void setDefault(boolean numericOnly) {
-	}
-
-	@Override
-	public void setDefault(int i, boolean numericOnly) {
-	}
-
-	@Override
-	public void setMin() {
-	}
-
-	@Override
-	public void setMin(int i) {
-	}
-
-	@Override
-	public void setMax() {
-	}
-
-	@Override
-	public void setMax(int i) {
-	}
 
 	@Override
@@ -63,9 +39,4 @@
 			elementAccess.save(sink);
 		}
-	}
-
-	@Override
-	public void load(SourceInterface stream) {
-		throw new UnimplementedException().msg("load in list access");
 	}
 
Index: java/main/src/main/java/com/framsticks/params/ListSource.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ListSource.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/params/ListSource.java	(revision 101)
@@ -5,12 +5,12 @@
 import java.util.List;
 
-public class ListSource implements SourceInterface {
+public class ListSource implements Source {
 
 	private Iterator<String> iterator = null;
-	//private final List<String> source;
+	private final List<String> list;
 
-	public ListSource(List<String> source) {
-		//this.source = source;
-		iterator = source.iterator();
+	public ListSource(List<String> list) {
+		this.list = list;
+		iterator = list.iterator();
 	}
 
@@ -38,5 +38,5 @@
 
 	@Override
-	public SourceInterface openInclude(String include) {
+	public Source openInclude(String include) {
 		return null;
 	}
@@ -59,3 +59,20 @@
 		return iterator == null;
 	}
+
+	@Override
+	public String toString() {
+		if (list.isEmpty()) {
+			return "?";
+		}
+		StringBuilder b = new StringBuilder();
+		int print = Math.min(list.size(), 3);
+		for (int i = 0; i < print; ++i) {
+			if (i != 0) {
+				b.append(" ");
+			}
+			b.append(list.get(i));
+		}
+		return b.toString();
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/params/ObjectAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ObjectAccess.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/ObjectAccess.java	(revision 101)
@@ -0,0 +1,5 @@
+package com.framsticks.params;
+
+public interface ObjectAccess extends Access {
+
+}
Index: java/main/src/main/java/com/framsticks/params/Param.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Param.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/params/Param.java	(revision 101)
@@ -96,8 +96,4 @@
 	}
 
-	public boolean isUserHidden() {
-		return (flags & ParamFlags.USERHIDDEN) != 0;
-	}
-
 	public static ParamBuilder build() {
 		return new ParamBuilder();
Index: java/main/src/main/java/com/framsticks/params/ParamCandidate.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ParamCandidate.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/params/ParamCandidate.java	(revision 101)
@@ -10,4 +10,5 @@
 import java.lang.reflect.ParameterizedType;
 import java.lang.reflect.Type;
+import java.util.ArrayList;
 import java.util.Arrays;
 import java.util.Collection;
@@ -15,4 +16,6 @@
 import java.util.Comparator;
 import java.util.HashMap;
+import java.util.HashSet;
+import java.util.IdentityHashMap;
 import java.util.LinkedList;
 import java.util.List;
@@ -75,4 +78,5 @@
 	protected final OneTime<Method> adder = new OneTime<>("adder");
 	protected final OneTime<Method> remover = new OneTime<>("remover");
+	protected int flags = 0;
 
 	protected final List<ParamAnnotation> annotations = new LinkedList<>();
@@ -162,4 +166,17 @@
 	public List<ParamAnnotation> getAnnotations() {
 		return Collections.unmodifiableList(annotations);
+	}
+
+	protected final java.util.Set<Class<?>> dependantClasses = new HashSet<>();
+
+	// public void addDependantClass(Class<?> javaClass) {
+	// 	dependantClasses.add(javaClass);
+	// }
+
+	/**
+	 * @return the dependantClasses
+	 */
+	public java.util.Set<Class<?>> getDependantClasses() {
+		return Collections.unmodifiableSet(dependantClasses);
 	}
 
@@ -247,4 +264,5 @@
 		this.name.set(name);
 		annotations.add(paramAnnotation);
+		flags |= paramAnnotation.flags();
 		if (member instanceof Field) {
 			field.set((Field) member);
@@ -299,5 +317,5 @@
 
 	public int getFlags() {
-		int f = 0;
+		int f = flags;
 		if (isReadOnly()) {
 			f |= ParamFlags.READONLY;
@@ -341,4 +359,5 @@
 		protected final Map<String, ParamCandidate> candidates;
 		protected final List<ParamCandidate> order;
+		protected final java.util.Set<Class<?>> dependantClasses = new HashSet<>();
 
 		/**
@@ -364,7 +383,17 @@
 			return order;
 		}
-	}
+
+		public java.util.Set<Class<?>> getDependentClasses() {
+			return dependantClasses;
+		}
+	}
+
+	protected static final Map<Class<?>, Set> setsCache = Collections.synchronizedMap(new IdentityHashMap<Class<?>, Set>());
 
 	public static Set getAllCandidates(Class<?> javaClass) throws ConstructionException {
+		Set result = setsCache.get(javaClass);
+		if (result != null) {
+			return result;
+		}
 
 		List<Class<?>> javaClasses = new LinkedList<>();
@@ -374,8 +403,9 @@
 		}
 
-		Set resultSet = new Set(new HashMap<String, ParamCandidate>(), new LinkedList<ParamCandidate>());
+		result = new Set(new HashMap<String, ParamCandidate>(), new LinkedList<ParamCandidate>());
 
 		for (Class<?> j : javaClasses) {
-			Set set = new Set(resultSet.getCandidates(), new LinkedList<ParamCandidate>());
+			Set set = new Set(result.getCandidates(), new LinkedList<ParamCandidate>());
+
 			filterParamsCandidates(set, j.getDeclaredFields());
 			filterParamsCandidates(set, j.getDeclaredMethods());
@@ -383,4 +413,13 @@
 			FramsClassAnnotation fa = j.getAnnotation(FramsClassAnnotation.class);
 			if (fa != null) {
+
+				if (j != javaClass) {
+					result.dependantClasses.add(j);
+				}
+				for (Class<?> r : fa.register()) {
+					result.dependantClasses.add(r);
+				}
+
+
 				final List<String> order = Arrays.asList(fa.order());
 				Collections.sort(set.getOrder(), new Comparator<ParamCandidate>() {
@@ -396,12 +435,16 @@
 				});
 			}
-			resultSet.getOrder().addAll(0, set.getOrder());
-		}
-
-		for (ParamCandidate pc : resultSet.getOrder()) {
+			result.getOrder().addAll(0, set.getOrder());
+		}
+
+		for (ParamCandidate pc : result.getOrder()) {
 			pc.validate();
-		}
-
-		return resultSet;
+			pc.induceParamType(Param.build());
+			result.dependantClasses.addAll(pc.getDependantClasses());
+		}
+
+		setsCache.put(javaClass, result);
+
+		return result;
 	}
 
@@ -425,3 +468,116 @@
 	}
 
+	protected ParamBuilder induceParamType(ParamBuilder builder, Type type) {
+		// if (type.equals(Void.TYPE)) {
+		// 	throw new ConstructionException().msg("void is not a valid type");
+		// }
+
+		if (type instanceof ParameterizedType) {
+			ParameterizedType p = (ParameterizedType) type;
+			Type rawType = p.getRawType();
+			Type containedType = null;
+			//TODO make implementation here
+			boolean map = false;
+			StringBuilder b = new StringBuilder();
+			if (rawType.equals(Map.class)) {
+				containedType = p.getActualTypeArguments()[1];
+				map = true;
+				b.append("l");
+			} else if (rawType.equals(List.class)) {
+				containedType = p.getActualTypeArguments()[0];
+				b.append("l");
+			} else if (rawType.equals(EventListener.class)) {
+				containedType = p.getActualTypeArguments()[0];
+				b.append("e");
+			}
+			if (!(containedType instanceof Class)) {
+				return builder;
+			}
+			b.append(" ");
+
+			Class<?> containedClass = (Class<?>) containedType;
+			FramsClassAnnotation fca = containedClass.getAnnotation(FramsClassAnnotation.class);
+			if (fca == null) {
+				throw new ConstructionException().msg("the contained class is not annotated").arg("class", containedClass);
+			}
+			dependantClasses.add(containedClass);
+			b.append(FramsClassBuilder.getName(fca, containedClass));
+			//TODO parameterize this
+			if (map) {
+				b.append(" uid");
+			}
+
+			builder.type(b.toString());
+			return builder;
+		}
+
+		if (type instanceof Class) {
+
+			Class<?> cl = (Class<?>) type;
+
+			// TODO: future support for enum
+			// if (cl.isEnum()) {
+			//	Class<? extends Enum<?>> enumType = (Class<? extends Enum<?>>) cl;
+			//	Enum<?>[] enums = enumType.getEnumConstants();
+			//	StringBuilder b = new StringBuilder();
+
+			//	b.append("d 0 ").append(enums.length - 1).append(" 0 ");
+			//	for (Enum<?> e : enums) {
+			//		b.append("~").append(e.name());
+			//	}
+			//	return b.toString();
+			// }
+			if (cl.equals(Integer.class) || cl.equals(int.class)) {
+				builder.type("d");
+				return builder;
+			}
+			if (cl.equals(String.class)) {
+				builder.type("s");
+				return builder;
+			}
+			if (cl.equals(Double.class) || cl.equals(double.class)) {
+				builder.type("f");
+				return builder;
+			}
+			if (cl.equals(Boolean.class) || cl.equals(boolean.class)) {
+				builder.type( "d 0 1");
+				return builder;
+			}
+			if (cl.equals(Object.class)) {
+				builder.type("x");
+				return builder;
+			}
+
+
+			// builder.type("o " + (cl).getCanonicalName());
+			builder.type("o " + cl.getSimpleName());
+			dependantClasses.add(cl);
+			builder.fillStorageType(cl);
+			return builder;
+		}
+
+		throw new ConstructionException().msg("failed to find framsticks for native type").arg("type", type);
+	}
+
+
+	public ParamBuilder induceParamType(ParamBuilder builder) {
+		Method method = getCaller();
+		if (method == null) {
+			return induceParamType(builder, getType());
+		}
+
+		if (!method.getReturnType().equals(Void.TYPE)) {
+			builder.resultType(induceParamType(Param.build(), method.getGenericReturnType()).finish(ValueParam.class));
+		}
+
+		List<ValueParam> arguments = new ArrayList<>();
+		int number = 0;
+		for (Type arg : method.getGenericParameterTypes()) {
+			arguments.add(induceParamType(Param.build(), arg).idAndName("arg" + (number++)).finish(ValueParam.class));
+		}
+		builder.argumentsType(arguments);
+
+		return builder;
+	}
+
 };
Index: java/main/src/main/java/com/framsticks/params/ParamsUtil.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ParamsUtil.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/ParamsUtil.java	(revision 101)
@@ -0,0 +1,90 @@
+package com.framsticks.params;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import com.framsticks.util.FramsticksException;
+
+
+import static com.framsticks.util.lang.Containers.filterInstanceof;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public abstract class ParamsUtil {
+
+	public static String readSourceToString(Source source) {
+		StringBuilder result = new StringBuilder();
+		String line;
+		while ((line = source.readLine()) != null) {
+			result.append(line).append(" ");
+		}
+		source.close();
+		return result.toString();
+	}
+
+	public static <T> List<T> stripAccess(List<Access> accesses, Class<T> type) {
+		List<T> result = new ArrayList<T>();
+		for (Access a : accesses) {
+			Object object = a.getSelected();
+			if (!type.isInstance(object)) {
+				throw new FramsticksException().msg("extracted object is of invalid type").arg("object", object).arg("desired", type).arg("actual", object.getClass()).arg("framsclass", a.getFramsClass());
+			}
+			result.add(type.cast(object));
+		}
+		return result;
+	}
+
+	public static int takeAllNonNullValues(Access to, Access from) {
+		int copied = 0;
+		for (ValueParam f : filterInstanceof(from.getParams(), ValueParam.class)) {
+			Object v = from.get(f, Object.class);
+			if (v == null) {
+				continue;
+			}
+			// if (to.get(f, Object.class) != null) {
+			//	continue;
+			// }
+			to.set(f, v);
+			++copied;
+		}
+		return copied;
+	}
+
+	public static int copyExistingParamsTypeSafe(Access to, Access from) {
+		int copied = 0;
+		for (ValueParam f : filterInstanceof(from.getParams(), ValueParam.class)) {
+			Param t = from.getParam(f.getId());
+			if (!(t instanceof ValueParam)) {
+				continue;
+			}
+			if (to.getClass() != f.getClass()) {
+				continue;
+			}
+			to.set((ValueParam) t, from.get(f, Object.class));
+			++copied;
+		}
+		return copied;
+	}
+
+	public static <T> T selectObjectForAccess(Access access, Object object, Class<T> type) {
+		if (object == null) {
+			return null;
+		}
+		if (!type.isInstance(object)) {
+			throw new FramsticksException().msg("trying to select object of wrong type").arg("object", object).arg("type", object.getClass()).arg("in", access);
+		}
+		return type.cast(object);
+	}
+
+	public static int getNumberOfCompositeParamChild(Access access, Object child) {
+		int count = access.getCompositeParamCount();
+		for (int i = 0; i < count; ++i) {
+			if (access.get(i, Object.class) == child) {
+				return i;
+			}
+		}
+		return -1;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/params/PropertiesAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/PropertiesAccess.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/params/PropertiesAccess.java	(revision 101)
@@ -76,5 +76,5 @@
 	@Override
 	public PropertiesAccess select(Object object) {
-		properties = Util.selectObjectForAccess(this, object, Map.class);
+		properties = ParamsUtil.selectObjectForAccess(this, object, Map.class);
 		return this;
 	}
Index: java/main/src/main/java/com/framsticks/params/ReflectionAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 101)
@@ -1,25 +1,14 @@
 package com.framsticks.params;
 
-import java.lang.reflect.Field;
 import java.lang.reflect.InvocationTargetException;
 import java.lang.reflect.Method;
-import java.util.ArrayList;
-import java.util.Collections;
-import java.util.Comparator;
-import java.util.HashMap;
-import java.util.IdentityHashMap;
-import java.util.List;
-import java.util.Map;
-
-import javax.annotation.concurrent.Immutable;
+
 
 import org.apache.logging.log4j.Logger;
 import org.apache.logging.log4j.LogManager;
 
-import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.types.EventParam;
 import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.util.FramsticksException;
-import com.framsticks.util.lang.Pair;
 
 import static com.framsticks.util.lang.Containers.*;
@@ -37,228 +26,7 @@
 
 	protected final Class<?> javaClass;
-	protected final Backend backend;
+	protected final ReflectionAccessBackend backend;
 
 	private Object object;
-
-	@Immutable
-	public static class Backend {
-
-		protected static final Map<Pair<Class<?>, FramsClass>, Backend> synchronizedCache = Collections.synchronizedMap(new HashMap<Pair<Class<?>, FramsClass>, Backend>());
-
-
-		public interface ReflectedGetter {
-			public <T> T get(Object object, Class<T> type) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
-		}
-
-		public interface ReflectedSetter {
-			public <T> void set(Object object, T value) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
-		}
-
-		public interface ReflectedCaller {
-			public Object call(Object object, Object[] arguments) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
-		}
-
-		public interface ReflectedAdder{
-			public void reg(Object object, EventListener<?> listener) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
-		}
-
-		public interface ReflectedRemover{
-			public void regRemove(Object object, EventListener<?> listener) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
-		}
-
-		protected final Map<ValueParam, ReflectedSetter> setters = new IdentityHashMap<>();
-		protected final Map<ValueParam, ReflectedGetter> getters = new IdentityHashMap<>();
-		protected final Map<ProcedureParam, ReflectedCaller> callers = new IdentityHashMap<>();
-		protected final Map<EventParam, ReflectedAdder> adders = new IdentityHashMap<>();
-		protected final Map<EventParam, ReflectedRemover> removers = new IdentityHashMap<>();
-
-		protected final List<Method> autoAppendMethods = new ArrayList<>();
-
-		/**
-		 * @param params
-		 */
-		public Backend() {
-		}
-
-		public static Backend getOrCreateFor(Class<?> reflectedClass, FramsClass framsClass) {
-
-			Pair<Class<?>, FramsClass> id = new Pair<Class<?>, FramsClass>(reflectedClass, framsClass);
-			Backend backend = synchronizedCache.get(id);
-			if (backend != null) {
-				return backend;
-			}
-
-			log.debug("constructing backend for {}", id);
-			backend = new Backend();
-
-			Map<String, ParamCandidate> candidates = ParamCandidate.getAllCandidates(reflectedClass).getCandidates();
-
-			try {
-				for (final ProcedureParam pp : filterInstanceof(framsClass.getParamEntries(), ProcedureParam.class)) {
-					if (!candidates.containsKey(pp.getId())) {
-						log.trace("java class does implement method {}", pp);
-						continue;
-					}
-					ParamCandidate pc = candidates.get(pp.getId());
-					final Method method = pc.getCaller();
-
-					backend.callers.put(pp, new ReflectedCaller() {
-
-						@Override
-						public Object call(Object object, Object[] arguments) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
-							return method.invoke(object, arguments);
-						}
-					});
-
-				}
-
-				for (final EventParam ep : filterInstanceof(framsClass.getParamEntries(), EventParam.class)) {
-					if (!candidates.containsKey(ep.getId())) {
-						log.trace("java class does not implement the event param {}", ep);
-						continue;
-					}
-					ParamCandidate ec = candidates.get(ep.getId());
-					final Method adder = ec.getAdder();
-					final Method remover = ec.getRemover();
-
-					backend.adders.put(ep, new ReflectedAdder() {
-
-						@Override
-						public void reg(Object object, EventListener<?> listener) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
-							adder.invoke(object, listener);
-						}
-					});
-
-					backend.removers.put(ep, new ReflectedRemover() {
-
-						@Override
-						public void regRemove(Object object, EventListener<?> listener) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
-							remover.invoke(object, listener);
-						}
-					});
-				}
-
-				for (final ValueParam vp : filterInstanceof(framsClass.getParamEntries(), ValueParam.class)) {
-					if (!candidates.containsKey(vp.getId())) {
-						throw new ConstructionException().msg("missing candidate for param").arg("param", vp);
-					}
-					ParamCandidate pc = candidates.get(vp.getId());
-					if (pc.isReadOnly() && !vp.hasFlag(ParamFlags.READONLY)) {
-						throw new ConstructionException().msg("readonly state conflict").arg("param", vp);
-					}
-					if (!typeMatch(pc.getRawType(), vp.getStorageType())) {
-						throw new ConstructionException().msg("types mismatch for param").arg("param", vp).arg("candidate", pc.getType()).arg("storage", vp.getStorageType());
-					}
-
-					final boolean primitive = pc.isPrimitive();
-					if (pc.getField() != null) {
-						final Field f = pc.getField();
-						backend.getters.put(vp, new ReflectedGetter() {
-							@Override
-							public <T> T get(Object object, Class<T> type) throws IllegalArgumentException, IllegalAccessException {
-								return type.cast(f.get(object));
-							}
-						});
-						if (!pc.isFinal()) {
-							backend.setters.put(vp, new ReflectedSetter() {
-								@Override
-								public <T> void set(Object object, T value) throws IllegalArgumentException, IllegalAccessException {
-									if (value == null && primitive) {
-										throw new FramsticksException().msg("setting null to primitive value");
-									}
-									f.set(object, value);
-								}
-							});
-						}
-					} else {
-						final Method g = pc.getGetter();
-
-						backend.getters.put(vp, new ReflectedGetter() {
-							@Override
-							public <T> T get(Object object, Class<T> type) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
-								return type.cast(g.invoke(object));
-							}
-						});
-
-						if (!pc.isFinal()) {
-							final Method s = pc.getSetter();
-							backend.setters.put(vp, new ReflectedSetter() {
-								@Override
-								public <T> void set(Object object, T value) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
-									if (value == null && primitive) {
-										throw new FramsticksException().msg("setting null to primitive value");
-									}
-									s.invoke(object, value);
-								}
-							});
-						}
-					}
-				}
-			} catch (ConstructionException e) {
-				throw e.arg("java class", reflectedClass).arg("framsClass", framsClass);
-			}
-
-			Class<?> javaClass = reflectedClass;
-			while (javaClass != null) {
-
-				for (Method m : javaClass.getDeclaredMethods()) {
-					AutoAppendAnnotation a = m.getAnnotation(AutoAppendAnnotation.class);
-					if (a == null) {
-						continue;
-					}
-					Class<?>[] args = m.getParameterTypes();
-					if (args.length != 1) {
-						throw new ConstructionException().msg("invalid number of arguments in AutoAppend marked method").arg("method", m).arg("arguments", args.length);
-					}
-					backend.autoAppendMethods.add(m);
-				}
-
-				javaClass = javaClass.getSuperclass();
-			}
-
-			Collections.sort(backend.autoAppendMethods, new Comparator<Method>() {
-
-				@Override
-				public int compare(Method m0, Method m1) {
-					Class<?> arg0 = m0.getParameterTypes()[0];
-					Class<?> arg1 = m1.getParameterTypes()[0];
-					if (arg0.isAssignableFrom(arg1)) {
-						return 1;
-					}
-					if (arg1.isAssignableFrom(arg0)) {
-						return -1;
-					}
-					return 0;
-				}
-			});
-
-			synchronizedCache.put(id, backend);
-			return backend;
-		}
-
-	}
-
-	public static boolean typeMatch(Class<?> a, Class<?> b) {
-		if (b.isPrimitive()) {
-			throw new FramsticksException().msg("failed to match type, right argument is primitive").arg("left", a).arg("right", b);
-		}
-		if (!a.isPrimitive()) {
-			return a.equals(b);
-		}
-
-		if (a.equals(int.class)) {
-			return b.equals(Integer.class);
-		}
-		if (a.equals(double.class)) {
-			return b.equals(Double.class);
-		}
-		if (a.equals(boolean.class)) {
-			return b.equals(Boolean.class);
-		}
-		throw new FramsticksException().msg("failed to match types").arg("left", a).arg("right", b);
-	}
-
-
-
 
 	public ReflectionAccess(Class<?> javaClass) throws ConstructionException {
@@ -268,8 +36,8 @@
 
 	public ReflectionAccess(Class<?> javaClass, FramsClass framsClass) throws ConstructionException {
-		this(javaClass, framsClass, Backend.getOrCreateFor(javaClass, framsClass));
-	}
-
-	protected ReflectionAccess(Class<?> javaClass, FramsClass framsClass, Backend backend) throws ConstructionException {
+		this(javaClass, framsClass, ReflectionAccessBackend.getOrCreateFor(javaClass, framsClass));
+	}
+
+	protected ReflectionAccess(Class<?> javaClass, FramsClass framsClass, ReflectionAccessBackend backend) throws ConstructionException {
 		super(framsClass);
 		this.javaClass = javaClass;
@@ -278,5 +46,5 @@
 
 	@Override
-	public ReflectionAccess cloneAccess() throws ConstructionException {
+	public ReflectionAccess cloneAccess() {
 		return new ReflectionAccess(javaClass, framsClass, backend);
 	}
@@ -290,5 +58,5 @@
 				}
 
-				return backend.getters.get(param).get(object, type);
+				return backend.getters.get(param.getId()).get(object, type);
 			} catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException e) {
 				throw new FramsticksException().msg("failed to get").cause(e);
@@ -310,5 +78,5 @@
 					throw new FramsticksException().msg("no object set");
 				}
-				Backend.ReflectedSetter s = backend.setters.get(param);
+				ReflectionAccessBackend.ReflectedSetter s = backend.setters.get(param.getId());
 				if (s == null) {
 					throw new FramsticksException().msg("trying to set unsettable");
@@ -334,5 +102,5 @@
 				}
 
-				backend.adders.get(param).reg(object, listener);
+				backend.adders.get(param.getId()).reg(object, listener);
 				return;
 			} catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException e) {
@@ -352,5 +120,5 @@
 				}
 
-				backend.removers.get(param).regRemove(object, listener);
+				backend.removers.get(param.getId()).regRemove(object, listener);
 				return;
 			} catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException e) {
@@ -364,15 +132,10 @@
 	@Override
 	public Object call(String id, Object[] arguments) {
-		return call(framsClass.getParamEntry(id, ProcedureParam.class), arguments);
-	}
-
-	@Override
-	public Object call(ProcedureParam param, Object[] arguments) {
-		try {
-			try {
-				if (object == null) {
-					throw new FramsticksException().msg("no object set");
-				}
-				Backend.ReflectedCaller c = backend.callers.get(param);
+		try {
+			try {
+				if (object == null) {
+					throw new FramsticksException().msg("no object set");
+				}
+				ReflectionAccessBackend.ReflectedCaller c = backend.callers.get(id);
 				if (c == null) {
 					throw new FramsticksException().msg("method is not bound");
@@ -383,10 +146,11 @@
 			}
 		} catch (FramsticksException e) {
-			throw e.arg("param", param).arg("access", this);
-		}
-	}
-
-	void resetErrors() {
-		//TODO this replaces returnedObject.resetErrors();
+			throw e.arg("param", framsClass.getParam(id)).arg("access", this);
+		}
+	}
+
+	@Override
+	public Object call(ProcedureParam param, Object[] arguments) {
+		return call(param.getId(), arguments);
 	}
 
@@ -396,6 +160,4 @@
 			return;
 		}
-
-		resetErrors();
 
 		try {
@@ -416,5 +178,5 @@
 	@Override
 	public ReflectionAccess select(Object object) {
-		this.object = Util.selectObjectForAccess(this, object, javaClass);
+		this.object = ParamsUtil.selectObjectForAccess(this, object, javaClass);
 		return this;
 	}
@@ -425,22 +187,4 @@
 	}
 
-	// TODO: find a better place for it
-	public static String objectToString(Object object) {
-		StringBuilder b = new StringBuilder();
-		for (Field f : object.getClass().getFields()) {
-			b.append(f.getName());
-			b.append(":");
-			try {
-				Object value = f.get(object);
-				b.append((value != null) ? value.toString() : "<null>");
-			} catch (IllegalAccessException e) {
-				e.printStackTrace();
-			}
-			b.append("\n");
-		}
-		return b.toString();
-	}
-
-
 	@Override
 	public Object createAccessee() {
@@ -448,10 +192,7 @@
 			return javaClass.newInstance();
 		} catch (InstantiationException | IllegalAccessException e) {
-			e.printStackTrace();
-		}
-		log.fatal("failed to create reflected object of class {} for frams type {}", javaClass.getCanonicalName(), framsClass.getId());
-		return null;
-	}
-
+			throw new FramsticksException().msg("failed to create reflected object").arg("java class", javaClass).arg("frams class", framsClass).cause(e);
+		}
+	}
 
 	@Override
